#include "ti83plus.inc"
.org $9D93
.dw  $6DBB
;Made to emulate xLIB's real(10...) command. Something about copy.
;Inputs: Ans=ProgName. If this arg is a num, assume to delete item.
;        X  =ProgNum
;
ProgramStart:
 bcall(_RclAns)
 ld a,(Op1)
 or a
 jr z,DelEntry
 cp 4
 ret nz   ;kill program if not either 0 nor 4.
 
 ld hl,Op1
 ld (hl),5
 inc hl
 ex de,hl
 ld a,(hl)
 and %00001111   ;doesn't need to be exact. Just prevent crash.
 ret z
 ld c,a
 ld b,0
 inc hl
 inc hl
 ldir
 xor a
 ld (de),a
 bcall(_ChkFindSym)
 ret c
 ld a,b
 or a
 ret z
 bcall(_SetupPagedPtr)
 ld b,10
 call ReadFlash
 ld b,a
 call ReadFlash
 call GetProgFile
 ret nc
 ld b,2
 call ReadFlash
 push hl
  bcall(_CreateProtProg)
 pop bc
 inc de
 inc de
 bcall(_PagedGet)
 ld (de),a
 inc de
 dec bc
 ld a,b
 or c
 jr nz,$-8
 ret
 
DelEntry:
 call GetProgFile
 ret c
 bcall(_DelVarArc)
 ret

ReadFlash:  ;B=#ofbytestoread. A=lastbyteread
 bcall(_PagedGet)
 ld l,h
 ld h,a
 djnz $-5
 ret

GetProgFile:
 bcall(_RclX)
 bcall(_ConvOp1)
 ld a,e
 cp 10
 jr c,$+4
 pop af
 ret
 add a,$30
 ld de,Op1
 ld hl,TempProgName
 ld bc,8
 ldir
 ld (de),a
 bcall(_ChkFindSym)
 ret

TempProgName:
.db 5,"XTEMP00"


.echo "-------------------------------\n"
.echo "Prog XCOPY size: "
.echo $-programstart
.echo " bytes.\n"
.echo "-------------------------------\n"
.end
